﻿/*
 * АЦР.c
 *
 * Created: 15.01.2014 9:49:41
 * Author: Писанец Александр Николаевич
 */ 

#include <avr/io.h>
#include <avr/interrupt.h> // библиотека прирываний
unsigned char Sifra[]= {63,6,93,79,102,107,123,7,127,111}; // код символов для индикатора
unsigned char Razrad = 3,Razrad1,Razrad2,Razrad3,Razrad4;
unsigned int ACP;
 ISR  (TIMER0_COMP_vect)  //прерывание таймера T0 работа с разрядами индикатора 
  { 
	PORTD = 0;            
    switch (Razrad)      //определяем с каким разрятом на индикаторе будем работать      
     { 
       case 3:
	     if ( Razrad4 == 0)          //проверка на отображение 
		    break;			         // поскольку ноль то не засвечиваем разряд 
		  else
		    PORTB = Sifra [Razrad4]; //берем код символа для отображения на индикаторе (отображаем тысячи)           
		 PORTD |=(1<<Razrad); 	     //засвечиваем разряд индикатора	  
       break; 
	   //===============
	   case 4:
	     if (Razrad4 == 0)          //проверка на результат ноль (тысячи)         
	      {
		    if ( Razrad3 == 0)      //проверка на результат ноль (сотни)  
		     break;		            //поскольку везде ноль не засвечиваем разряд  	    		 
	      }
	     PORTB = Sifra [Razrad3];  //берем код символа для отображения на индикаторе (отображаем сотни) 	 	          
		 PORTD |=(1<<Razrad); 	   //засвечиваем разряд индикатора	  
       break; 
	   //===============
	  case 5:
	     if (Razrad4 == 0)        //проверка на результат ноль (тысячи)      
	      {
		    if ( Razrad3 == 0)    //проверка на результат ноль (сотни) 
		     {
			   if ( Razrad2 == 0) //проверка на результат ноль (десятки) 
		        break;	          //поскольку везде ноль не засвечиваем разряд  
			 }				 			    		 
	      }
	     PORTB = Sifra [Razrad2]; //берем код символа для отображения на индикаторе (отображаем десятки)         
		 PORTD |=(1<<Razrad); 	  //засвечиваем разряд индикатора		  
       break;
	   //============== 
	   case 6:
	     PORTB = Sifra [Razrad1]; //берем код символа для отображения на индикаторе (отображаем единицы)          
		 PORTD |=(1<<Razrad);     //засвечиваем разряд индикатора	
		 Razrad = 2; 		      
       break;                                             
     } 
	Razrad ++;          
  } 
 ISR  (ADC_vect)         //преобразование АЦР завершено            
  {  
     ACP = ADCW;         //считуем значения АСР
     // ====== //
     Razrad4 = 0;        //регистр для результата тысяч
	 while(ACP >= 1000)  //узнаем тысячи
	  {
		ACP = ACP - 1000;
		Razrad4 ++;   
	  }
	 Razrad3 =0;         //регистр для результата сотен
	 while(ACP >= 100)
	  {
		ACP = ACP - 100; // сотни
		Razrad3 ++;   
	  } 
	 Razrad2 = 0 ;       //регистр для результата десятков
	 while(ACP >= 10)    //десятки
	  {
		ACP = ACP - 10;
		Razrad2 ++;   
	  }
	 Razrad1 = ACP;   	//единицы 	   
     ADCSRA |=(1<<ADSC);//запускаем работу АЦР 
	 
  } 
  //==================//
  int main(void)
  { 
	DDRB = 255;  
	PORTB = 0; 
	DDRD = 255; 
	PORTD = 0; 
  //==========// 
	OCR0=44;             
    TCCR0=0b00001011;  
    TIMSK|=(1<<1); 
  //=========//	  	         
	DDRA&=~(1<<0);
    ADCSRA|=(1<<ADEN)|(1<<ADIE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);  //вкл. АСР(ADEN), разрешение прерывания(ADIE), пределитель 128(ADPS2..ADPS0)   
    ADMUX |=(1<<REFS0)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);	   // источник напряжения AVcc(REFS1..REFS0),выбор входного канала PORTA.0 (MUX4..MUX0)
	ADCSRA |=(1<<ADSC); //запускаем  АЦР 
	//============//    
	asm("sei");
    while(1)
     {
      asm ("nop");
	  asm ("nop");
	  	
	 }     
  }
  
   